package de.kurka.gwt.exaample.mvp.client;

import com.google.gwt.app.place.ActivityManager;
import com.google.gwt.app.place.PlaceController;
import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.dom.client.Style.Unit;
import com.google.gwt.event.shared.HandlerManager;
import com.google.gwt.user.client.ui.DockLayoutPanel;
import com.google.gwt.user.client.ui.RootLayoutPanel;

import de.kurka.gwt.exaample.mvp.client.display.SimpleDisplay;
import de.kurka.gwt.exaample.mvp.client.places.HomePlace;

/**
 * Entry point classes define <code>onModuleLoad()</code>.
 */
public class MVPExample implements EntryPoint {

	public void onModuleLoad() {

		SimpleDisplay headDisplay = new SimpleDisplay();
		SimpleDisplay navDisplay = new SimpleDisplay();
		SimpleDisplay mainDisplay = new SimpleDisplay();

		DockLayoutPanel p = new DockLayoutPanel(Unit.EM);
		p.addNorth(headDisplay.getContainer(), 2);
		p.addWest(navDisplay.getContainer(), 10);
		p.add(mainDisplay.getContainer());

		RootLayoutPanel.get().add(p);

		HandlerManager eventBus = new HandlerManager(null);

		TopActivityMapper topActivityMapper = new TopActivityMapper();
		ActivityManager topActicityManager = new ActivityManager(topActivityMapper, eventBus);
		topActicityManager.setDisplay(headDisplay);

		CenterActivityMapper centerActivityMapper = new CenterActivityMapper();
		ActivityManager activityManager = new ActivityManager(centerActivityMapper, eventBus);
		activityManager.setDisplay(mainDisplay);

		LeftActivityMapper leftActivityMapper = new LeftActivityMapper();
		ActivityManager leftActivityManager = new ActivityManager(leftActivityMapper, eventBus);
		leftActivityManager.setDisplay(navDisplay);

		PlaceController placeController = new PlaceController(eventBus);
		PlaceControllerSingleton.getInstance().setPlaceController(placeController);
		placeController.goTo(new HomePlace());
	}
}
