package de.kurka.gwt.exaample.mvp.client.activities;

import com.google.gwt.app.place.Activity;
import com.google.gwt.app.place.IsWidget;
import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.event.dom.client.HasClickHandlers;
import com.google.gwt.event.shared.EventBus;

import de.kurka.gwt.exaample.mvp.client.PlaceControllerSingleton;
import de.kurka.gwt.exaample.mvp.client.places.AdminPlace;
import de.kurka.gwt.exaample.mvp.client.places.HomePlace;
import de.kurka.gwt.exaample.mvp.client.places.UserPlace;

public class NavActivity implements Activity {

	private final NavDisplay navDisplay;

	public NavActivity(NavDisplay navDisplay) {
		this.navDisplay = navDisplay;

	}

	public interface NavDisplay extends IsWidget {
		public HasClickHandlers getUserButton();

		public HasClickHandlers getAdminButton();

		public HasClickHandlers getHomePlace();
	}

	@Override
	public String mayStop() {
		return null;
	}

	@Override
	public void onCancel() {

	}

	@Override
	public void onStop() {

	}

	@Override
	public void start(Display panel, EventBus eventBus) {
		panel.showActivityWidget(navDisplay);

		navDisplay.getAdminButton().addClickHandler(new ClickHandler() {

			@Override
			public void onClick(ClickEvent event) {
				PlaceControllerSingleton.getInstance().getPlaceController().goTo(new AdminPlace());

			}
		});

		navDisplay.getHomePlace().addClickHandler(new ClickHandler() {

			@Override
			public void onClick(ClickEvent event) {
				PlaceControllerSingleton.getInstance().getPlaceController().goTo(new HomePlace());

			}
		});

		navDisplay.getUserButton().addClickHandler(new ClickHandler() {

			@Override
			public void onClick(ClickEvent event) {
				PlaceControllerSingleton.getInstance().getPlaceController().goTo(new UserPlace());

			}
		});
	}
}
